def gv

pipeline {
    agent any
    parameters {
        choice(name: 'VERSION', choices: ['1.1.0', '1.2.0', '1.3.0'], description: '')
        booleanParam(name: 'executeTests', defaultValue: true, description: '')
    }
    tools {
        maven 'Maven' //name 'Maven' should be the same as it is configured in Jenkins
    }
    stages {
        stage("init") {
            steps {
                script {
                    echo "Init the application for branch $BRANCH_NAME"
                    gv = load "script.groovy"
                }
            }
        }
        stage("build jar") {
            steps {
                script {
                    gv.buildJar()

                }
            }
        }

        stage("build image") {
            when {
                expression {
                    BRANCH_NAME = 'master'
                }
            }
            steps {
                script {
                    gv.buildImage()
                }
            }
        }
// two different ways to have 'choices'
        stage("deploy") {
            when {
                expression {
                    BRANCH_NAME = 'master'
                }
            }
            input {
                message "Select the environment to deploy to"
                ok "Done"
                parameters {
                    choice(name: 'ENV', choices: ['dev', 'staging', 'prod'], description: '')
                }
            }
            steps {
                script {
                    env.ENV_TWO = input message: "Select the environment to deploy to", ok: "Done", parameters: [
                            choice(name: 'ENV', choices: ['dev', 'staging', 'prod'], description: '')
                    ]
                    gv.deployApp()
                    echo "Deploying to ${ENV}"
                    echo "Deploying to ${ENV_TWO}"
                }
            }
        }
    }
} 
